zoukankan      html  css  js  c++  java
  • 2015 HUAS Summer Trainning #4~B

    Description

    Download as PDF
     

    Before the invention of book-printing, it was very hard to make a copy of a book. All the contents had to be re-written by hand by so calledscribers. The scriber had been given a book and after several months he finished its copy. One of the most famous scribers lived in the 15th century and his name was Xaverius Endricus Remius Ontius Xendrianus (Xerox). Anyway, the work was very annoying and boring. And the only way to speed it up was to hire more scribers.


    Once upon a time, there was a theater ensemble that wanted to play famous Antique Tragedies. The scripts of these plays were divided into many books and actors needed more copies of them, of course. So they hired many scribers to make copies of these books. Imagine you have m books (numbered $1, 2, dots, m$) that may have different number of pages ( $p_1, p_2, dots, p_m$) and you want to make one copy of each of them. Your task is to divide these books among k scribes, $k le m$. Each book can be assigned to a single scriber only, and every scriber must get a continuous sequence of books. That means, there exists an increasing succession of numbers $0 = b_0 <
b_1 < b_2, dots < b_{k-1} le b_k = m$ such that i-th scriber gets a sequence of books with numbers between bi-1+1 and bi. The time needed to make a copy of all the books is determined by the scriber who was assigned the most work. Therefore, our goal is to minimize the maximum number of pages assigned to a single scriber. Your task is to find the optimal assignment.

    Input 

    The input consists of N cases. The first line of the input contains only positive integer N. Then follow the cases. Each case consists of exactly two lines. At the first line, there are two integers m and k, $1 le k le m le 500$. At the second line, there are integers $p_1, p_2, dots p_m$ separated by spaces. All these values are positive and less than 10000000.

    Output 

    For each case, print exactly one line. The line must contain the input succession $p_1, p_2, dots p_m$ divided into exactly k parts such that the maximum sum of a single part should be as small as possible. Use the slash character (`/') to separate the parts. There must be exactly one space character between any two successive numbers and between the number and the slash.


    If there is more than one solution, print the one that minimizes the work assigned to the first scriber, then to the second scriber etc. But each scriber must be assigned at least one book.

    Sample Input 

    2
    9 3
    100 200 300 400 500 600 700 800 900
    5 4
    100 100 100 100 100
    

    Sample Output 

    100 200 300 400 500 / 600 700 / 800 900
    100 / 100 / 100 / 100 100、
    
    解题思路:这个题目可以用二分法做,大概的思路就是二分枚举求得满足题意的最大值之后,然后以这个最大值通过从后往前的方式划分成段,如果剩余可划分段与i+1的值相等(尽量靠前),则将剩余的段往前划分。“最大值尽量小”是一种很常见的优化目标。二分最小值x,把优化问题转化为判定问题p(x)。若设所有数之和为M,则二分次数为O(logM),计算p(x)的时间复杂度O(n)(从左到右扫描一次即可),因此总时间复杂度为O(nlogM)。还要注意的事是使用int可能会有溢出,最好是使用long long型的,注意书写格式就差不多了。
    程序代码:
    #include<stdio.h>
    #include<string.h>
    #define MAXD 510
    int K, M, a[MAXD], p[MAXD][MAXD], num[MAXD];
    void solve()
    {
        int i, j, k;
        long long int min, max, mid, ans;
        min = max = 0;
        for(i = 0; i < M; i ++)
        {
            scanf("%d", &a[i]);
            if(a[i] > min)
                min = a[i];
            max += a[i];
        }
        -- min;
        for(;;)
        {
            mid = (max + min) / 2;
            if(mid == min)
                break;
            ans = 0;
            for(j = k = 0; j < M; j ++)
            {
                if(ans + a[j] > mid)
                {
                    ++ k;
                    if(k == K)
                        break;
                    ans = 0;
                }
                ans += a[j];
            }
            if(j == M)
                max = mid;
            else
                min = mid;
        }
        ans = 0;
        memset(num, 0, sizeof(num));
        for(i = M - 1, k = K - 1; i >= 0;i --)
        {
            if(ans + a[i] > max || i == k - 1)
            {
                -- k;
                ans = 0;
            }
            ans += a[i];
            p[k][num[k] ++] = a[i];
        }
        for(i = 0; i < K; i ++)
        {
            for(j = num[i] - 1; j >= 0; j --)
            {
                if(i != 0 || j != num[i] - 1)
                    printf(" ");
                printf("%d", p[i][j]);
            }
            if(i != K - 1)
                printf(" /");
        }
        printf(" ");
    }
    int main()
    {
        int t;
        scanf("%d", &t);
        while(t --)
        {
            scanf("%d%d", &M, &K);
            solve();
        }
        return 0;
  • 相关阅读:
    54-Spiral Matrix
    查找、排序算法
    Java中Timer的使用
    2017/5/8总结 js数组及json(对象数组)操作
    asp.net 中文件上传的两种方式
    2017/4/24combox 使用
    2017/4/24 静态页,评论,购物车总结
    2017/4/23星期日 总结
    2017.4.16关于在线图书商城注册界面总结
    c#中的委托和事件
  • 原文地址:https://www.cnblogs.com/chenchunhui/p/4702976.html
Copyright © 2011-2022 走看看